Package org.optaplanner.core.impl.score.stream.drools.quad

## Class DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.quad.DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>
      - - org.optaplanner.core.impl.score.stream.drools.quad.DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- All Implemented Interfaces:
    `ConstraintStream`, `QuadConstraintStream<NewA,​NewB,​NewC,​NewD>`, `InnerQuadConstraintStream<NewA,​NewB,​NewC,​NewD>`

      public final class DroolsGroupingQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>
      extends DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.quad.DroolsAbstractQuadConstraintStream

      `parent`

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping, BiConstraintCollector<A,​B,​ResultContainerC,​NewC> collectorC, BiConstraintCollector<A,​B,​ResultContainerD,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping, QuadConstraintCollector<A,​B,​C,​D,​ResultContainerC,​NewC> collectorC, QuadConstraintCollector<A,​B,​C,​D,​ResultContainerD,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping, TriConstraintCollector<A,​B,​C,​ResultContainerC,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​ResultContainerD,​NewD> collectorD)` |
    `DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping, UniConstraintCollector<A,​ResultContainerC,​NewC> collectorC, UniConstraintCollector<A,​ResultContainerD,​NewD> collectorD)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DroolsQuadCondition<NewA,​NewB,​NewC,​NewD,​?>` | `getCondition()` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.quad.DroolsAbstractQuadConstraintStream

      `filter, getCardinality, getFromStreamList, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, createRuleItemBuilders, getChildStreams, getConstraintFactory, getExpectedJustificationTypes`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.quad.InnerQuadConstraintStream

      `impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.quad.QuadConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                    Function<A,​NewA> groupKeyAMapping,
                                                    Function<A,​NewB> groupKeyBMapping,
                                                    UniConstraintCollector<A,​ResultContainerC,​NewC> collectorC,
                                                    UniConstraintCollector<A,​ResultContainerD,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                    BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                    BiFunction<A,​B,​NewB> groupKeyBMapping,
                                                    BiConstraintCollector<A,​B,​ResultContainerC,​NewC> collectorC,
                                                    BiConstraintCollector<A,​B,​ResultContainerD,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                    TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                    TriFunction<A,​B,​C,​NewB> groupKeyBMapping,
                                                    TriConstraintCollector<A,​B,​C,​ResultContainerC,​NewC> collectorC,
                                                    TriConstraintCollector<A,​B,​C,​ResultContainerD,​NewD> collectorD)

    - #### DroolsGroupingQuadConstraintStream

          public DroolsGroupingQuadConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                    DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                    QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                    QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping,
                                                    QuadConstraintCollector<A,​B,​C,​D,​ResultContainerC,​NewC> collectorC,
                                                    QuadConstraintCollector<A,​B,​C,​D,​ResultContainerD,​NewD> collectorD)

  - ### Method Detail

    - #### getCondition

          public DroolsQuadCondition<NewA,​NewB,​NewC,​NewD,​?> getCondition()

      Specified by:
        `getCondition` in class `DroolsAbstractQuadConstraintStream<Solution_,​NewA,​NewB,​NewC,​NewD>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`